--[[
    MrInfernal's Language Learner v1.1
        Spam each language until you learn it
        Teach: Use a maxed language 100 times to teach group members

    Usage: /lua run milang [teach]|"LANG"
            Using teach will do 100 lines for maxed languages
            Teach a selected language
]]

local mq = require('mq')
local stayOpen = true

print("\arMrInfernal's \ax Language Learner \aov1.1")
print('Spam each language until you learn it')
print('Usage: \ao/lua run milang \ax[\atlang\ax]|[\agteach\ax]')
print('Teach a \atspecified language\ax. Put in quotes if two words.')
print('\agTeach\ax: Use a maxed language 100 times to teach group members\n')

if not mq.TLO.Group() then
    print('\arError\ax: You are not in a group! Closing!')
    stayOpen = false
end

-- Get list of languages known and skill
local myLangs = {}

local function getLangs(doAll)
    local langNum = 0
    for i = 1, 25 do
        local skill = mq.TLO.Me.LanguageSkill(i)()
        if skill > 0 then
            langNum = langNum +1
            if doAll then
                table.insert(myLangs, {lang = mq.TLO.Me.Language(i)(), num = langNum})
            elseif not doAll then
                if skill < 100 then
                    table.insert(myLangs, {lang = mq.TLO.Me.Language(i)(), num = langNum})
                end
            end
        end
    end
end

local langList = {"Common",
"Barbarian",
"Erudian",
"Elvish",
"Dark Elvish",
"Dwarvish",
"Troll",
"Ogre",
"Gnomish",
"Halfling",
"Thieves Cant",
"Old Erudian",
"Elder Elvish",
"Froglok",
"Goblin",
"Gnoll",
"Combine Tongue",
"Elder Teir'Dal",
"Lizardman",
"Orcish",
"Faerie",
"Dragon",
"Elder Dragon",
"Dark Speech",
"Vah Shir"}

local function langText()
    mq.cmd('/gsay There once was a runner named Dwight,')
    mq.delay(250)
    mq.cmd('/gsay Who could speed even faster than light.')
    mq.delay(250)
    mq.cmd('/gsay He set out one day,')
    mq.delay(250)
    mq.cmd('/gsay In a relative way,')
    mq.delay(250)
    mq.cmd('/gsay And returned on the previous night.')
    mq.delay(250)
end

local function doLangs(args)
    local doAll = false
    local teachLang = ''

    if args ~= nil then
        if args:lower() == 'teach' then
            doAll = true
        else
            for _, check in pairs(langList) do
                if check:lower() == args:lower() then
                    teachLang = check
                    doAll = true
                end
            end
        end
    end

    getLangs(doAll)

    if args ~= nil then
        for _, teach in ipairs(myLangs) do
            if teach.lang == teachLang then
                mq.cmdf('/lang %d', teach.num)
                printf('Now teaching \ao%s\ax.', teach.lang)
                for i = 1, 20 do
                    langText()
                end
                print('Language teaching complete. Closing now.')
                stayOpen = false
            end
        end
    end

    if teachLang == '' then
        local langNum = 1
        for _, speak in ipairs(myLangs) do
            local skill = mq.TLO.Me.LanguageSkill(speak.lang)()
            if skill == 100 and doAll then
                mq.cmdf('/lang %d', speak.num)
                printf('[%d/%d] \ao%s \axis \at100\ax. Speak it 100 times.', langNum, #myLangs, speak.lang)
                langNum = langNum + 1
                for i = 1, 20 do
                    langText()
                end
            elseif skill < 100 and skill > 0 then
                printf('[%d/%d] \ao%s \axis \at%d\ax. Speaking until 100.', langNum, #myLangs, speak.lang, skill)
                langNum = langNum + 1
                mq.cmdf('/lang %d', speak.num)
                for i = 1, 200 do
                    langText()
                    if mq.TLO.Me.LanguageSkill(speak.lang)() == 100 then
                        printf('\ao%s \axis now \at100.', speak.lang)
                        break
                    end
                end
            end
        end
        print('Language learning complete. Closing now.')
        stayOpen = false
    end
end

local args = {...}
if #args == 1 then
    doLangs(args[1])
else
    doLangs()
end

while stayOpen do
    mq.doevents()
    mq.delay(1000)
end